package com.example.utils;

public class MonitorMemory {

    public static void printMemoryUsage() {
        Runtime runtime = Runtime.getRuntime();

        long totalMemory = runtime.totalMemory();
        long freeMemory = runtime.freeMemory();
        long usedMemory = totalMemory - freeMemory;
        long maxMemory = runtime.maxMemory();

        System.out.println("=== Memory Usage ===");
        System.out.println("Used Memory: " + (usedMemory / 1024 / 1024) + " MB");
        System.out.println("Free Memory: " + (freeMemory / 1024 / 1024) + " MB");
        System.out.println("Total Memory: " + (totalMemory / 1024 / 1024) + " MB");
        System.out.println("Max Memory: " + (maxMemory / 1024 / 1024) + " MB");
        System.out.println("====================");
    }

    public static void startMemoryMonitor() {
        Thread monitorThread = new Thread(() -> {
            try {
                while (true) {
                    printMemoryUsage();
                    Thread.sleep(5000); // 5 seconds
                }
            } catch (InterruptedException e) {
                System.out.println("Memory monitor interrupted.");
            }
        });

        monitorThread.setDaemon(true); // So it won't block program exit
        monitorThread.start();
    }
}
